From 97d3d53db5a71c8380e75b2aa4214421156cd588 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Sep 28 2017 17:35:09 +0000
Subject: [PATCH 959/1001] React-based widgets are allowed to have no root view


---

diff --git a/hubs/tests/widgets/test_halp.py b/hubs/tests/widgets/test_halp.py
index f160993..53c27f6 100644
--- a/hubs/tests/widgets/test_halp.py
+++ b/hubs/tests/widgets/test_halp.py
@@ -3,8 +3,8 @@ from __future__ import unicode_literals, absolute_import
 import json
 
 from hubs.app import app
-from hubs.models import Hub, User
-from hubs.tests import FakeAuthorization, widget_instance
+from hubs.models import Hub
+from hubs.tests import widget_instance
 from hubs.widgets import registry
 from . import WidgetTest
 
@@ -110,13 +110,6 @@ class HalpViewsTestCase(WidgetTest):
                 })
         return data
 
-    def test_root(self):
-        response = self.check_url('/ralph/w/halp/%i/' % self.widget.idx)
-        self.assertEqual(response.context["hubs"], ['fedora-devel'])
-
-    def test_view_authz(self):
-        self._test_view_authz()
-
     def test_props(self):
         with app.test_request_context('/'):
             props = self.widget.get_props()
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index be454bd..5dd0a8d 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -27,7 +27,7 @@ In order to be valid, a widget must:
 - have a valid :py:attr:`~hubs.widgets.base.Widget.name` attribute,
 - have a valid :py:attr:`~hubs.widgets.base.Widget.position` attribute,
 - contain at least one widget view named "``root``", registered for the "``/``"
-  URL.
+  URL, unless the widget is React-based.
 
 A widget view is a class which inherits from the
 :py:class:`hubs.widgets.view.WidgetView` class.  A widget can have one or more
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 5523385..db63192 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -116,12 +116,14 @@ class Widget(object):
                 )
         root_view = self.get_views().get("root")
         if root_view is None:
-            raise AttributeError(
-                'widgets must have a "root" view, please refer to the '
-                'documentation.')
-        if "/" not in root_view.url_rules:
-            raise AttributeError(
-                'the root view must be registered for the "/" URL rule.')
+            if not self.is_react:
+                raise AttributeError(
+                    'widgets must have a "root" view, please refer to the '
+                    'documentation.')
+        else:
+            if "/" not in root_view.url_rules:
+                raise AttributeError(
+                    'the root view must be registered for the "/" URL rule.')
 
     def get_parameters(self):
         """
diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
index a9a265d..d6c4c61 100644
--- a/hubs/widgets/feed/__init__.py
+++ b/hubs/widgets/feed/__init__.py
@@ -8,7 +8,7 @@ import flask
 from hubs.feed import format_msgs
 from hubs.widgets import validators
 from hubs.widgets.base import Widget
-from hubs.widgets.view import WidgetView, RootWidgetView
+from hubs.widgets.view import WidgetView
 
 from .functions import GetData
 
@@ -43,15 +43,6 @@ class Feed(Widget):
         return props
 
 
-class BaseView(RootWidgetView):
-
-    def get_context(self, instance, *args, **kwargs):
-        return dict(
-            title=self.widget.label,
-            disable_autoreload=True,
-            )
-
-
 class ExistingView(WidgetView):
 
     name = "existing"
diff --git a/hubs/widgets/halp/views.py b/hubs/widgets/halp/views.py
index dfd1e30..184140f 100644
--- a/hubs/widgets/halp/views.py
+++ b/hubs/widgets/halp/views.py
@@ -4,12 +4,9 @@ import datetime
 import time
 
 import flask
-from flask.signals import template_rendered
 
 from hubs.models import Hub
-from hubs.utils.views import get_hub, require_hub_access
-from hubs.widgets import registry
-from hubs.widgets.view import WidgetView, RootWidgetView
+from hubs.widgets.view import WidgetView
 from .functions import GetRequests
 from .utils import find_hubs_for_msg, paginate
 
@@ -19,17 +16,6 @@ except ImportError:
     before_render_template = None  # Flask < 0.11
 
 
-class BaseView(RootWidgetView):
-    """The base view to instantiate the widget."""
-
-    def get_context(self, instance, *args, **kwargs):
-        return dict(
-            hubs=instance.config.get("hubs", []),
-            title=self.widget.label,
-            disable_autoreload=True,
-            )
-
-
 class DataView(WidgetView):
     """Get the requests in JSON format."""
 
diff --git a/hubs/widgets/view.py b/hubs/widgets/view.py
index fce34b3..86dd615 100644
--- a/hubs/widgets/view.py
+++ b/hubs/widgets/view.py
@@ -22,7 +22,8 @@ class WidgetView(View):
     - the :py:meth:`.get_context` method must be implemented
 
     Every widget must have a view with the name "``root``" registered to
-    ``['/']``, which will be the main entry point for the widget.
+    ``['/']`` (unless they are React-based). This view will be the main entry
+    point for the widget.
 
     The resulting endpoint will be composed using the widget name and the view
     name as ``<widget_name>_<view_name>``, for example ``meetings_root``.

